#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE
#define MIN_AMS 101
#define leave(str) {ST_helpMsg(str); push_quantum(NOTHING_TAG); return;}
#define swap(a, b) { tmp = a; a = b; b = tmp; }
#define each(i, x) for (i = 0; i < x; i++)

#include <tigcclib.h>
typedef unsigned long long VLI;	//very long integer
typedef unsigned uint;

//Check if the ESI pointer is an integer
short is_positive_integer (ESI ptr)
{
  return (*ptr == POSINT_TAG);
}

void rad_sort_u(uint *from, uint *to, uint bit)
{
	if (!bit || to < from + 1) return;
 
	uint *ll = from, *rr = to - 1, tmp;
	while (1) {
		/* find left most with bit, and right most without bit, swap */
		while (ll < rr && !(*ll & bit)) ll++;
		while (ll < rr &&  (*rr & bit)) rr--;
		if (ll >= rr) break;
		swap(*ll, *rr);
	}
 
	if (!(bit & *ll) && ll < to) ll++;
	bit >>= 1;
 
	rad_sort_u(from, ll, bit);
	rad_sort_u(ll, to, bit);
}
 
static void radix_sort(int *a, const size_t len)
{
	size_t i;
	uint *x = (uint*) a;
 
	each(i, len) x[i] ^= INT_MIN;
	rad_sort_u(x, x + len, INT_MIN);
	each(i, len) x[i] ^= INT_MIN;
}
 
static inline void radix_sort_unsigned(uint *a, const size_t len)
{
	rad_sort_u(a, a + len, (uint)INT_MIN);
}

void _main(void)
{
	ESI argptr = top_estack;
	
	//Yhe first argument of the TIOS function is the length of the list
	VLI dimension = GetLongLongArg(argptr); 
	VLI i = 0;
	
	//The dynamic array
	int* array = (int*) malloc(dimension * sizeof(int));
	
	//If the second argument is a list
	if(*argptr == LIST_TAG) 
	{
		//Check if all elements of the list are integers
		//Argptr must be decremented by one to point to first element of the list
		if(!all_tail(is_positive_integer, --argptr))	
		{
			leave("List elements must be integers >= 0.");
		}
		else
			while(i<dimension && *argptr != END_TAG) array[i++]=GetLongLongArg(argptr);
	}
	
	radix_sort(array, dimension);
	
	push_END_TAG();
	for(i=dimension; i>0; i--) push_longlongint(array[i-1]);
	push_LIST_TAG();
}